define({"topics" : [{"title":"Getting started with routing","shortdesc":"<p class=\"shortdesc\"> To understand how the <span class=\"keyword\">NGFW<\/span> Engine reads routing definitions, look at the network interfaces in the routing or antispoofing                                 configurations.<\/p>","id":"GUID-5275686B-0863-4AA6-A709-ED0D206E8781","href":"GUID-5275686B-0863-4AA6-A709-ED0D206E8781.html","menu": {"hasChildren":false,},"tocID":"GUID-5275686B-0863-4AA6-A709-ED0D206E8781-d58e113109","topics":[]},{"title":"Routing configuration overview","shortdesc":"<p class=\"shortdesc\"> Routing configuration involves adding a default route, adding routes to networks that are not directly connected, and adding routes to networks that can be reached through route-based \t\tVPNs. <\/p>","id":"GUID-2F7BE0FD-DE94-4E7E-BC09-D617397AD05D","href":"GUID-2F7BE0FD-DE94-4E7E-BC09-D617397AD05D.html","menu": {"hasChildren":true,},"tocID":"GUID-2F7BE0FD-DE94-4E7E-BC09-D617397AD05D-d58e113143","next":"GUID-2F7BE0FD-DE94-4E7E-BC09-D617397AD05D-d58e113143",},{"title":"Add routers","shortdesc":"<p class=\"shortdesc\">A Router element represents a next-hop gateway’s IP address in routing configurations. <\/p>","id":"GUID-93FD8CBF-1780-4CDC-A53B-44CD520E877F","href":"GUID-93FD8CBF-1780-4CDC-A53B-44CD520E877F.html#GUID-93FD8CBF-1780-4CDC-A53B-44CD520E877F","menu": {"hasChildren":false,},"tocID":"GUID-93FD8CBF-1780-4CDC-A53B-44CD520E877F-d58e113307","topics":[]},{"title":"Add or view the default route","shortdesc":"<p class=\"shortdesc\">You can check which route is currently set as the default route for traffic leaving the <span class=\"keyword\">NGFW<\/span> Engine and set a new default route.<\/p>","id":"GUID-ACD5064E-A371-4E14-900A-27B0E2068D36","href":"GUID-ACD5064E-A371-4E14-900A-27B0E2068D36.html#GUID-ACD5064E-A371-4E14-900A-27B0E2068D36","menu": {"hasChildren":false,},"tocID":"GUID-ACD5064E-A371-4E14-900A-27B0E2068D36-d58e113388","topics":[]},{"title":"Add static routes","shortdesc":"<p class=\"shortdesc\"> You can add a static route to a network in the routing configuration.<\/p>","id":"GUID-99D1230C-DBE6-449F-8EDB-82265BF14AA6","href":"GUID-99D1230C-DBE6-449F-8EDB-82265BF14AA6.html#GUID-99D1230C-DBE6-449F-8EDB-82265BF14AA6","menu": {"hasChildren":false,},"tocID":"GUID-99D1230C-DBE6-449F-8EDB-82265BF14AA6-d58e113456","topics":[]},{"title":"Using metrics or ECMP on multiple routes to the same destination","shortdesc":"<p class=\"shortdesc\">You can configure multiple routes through different next hop gateways to the \t\tsame destination.<\/p>","id":"GUID-D0594A4B-99B7-41F9-869A-0DA629402F46","href":"GUID-D0594A4B-99B7-41F9-869A-0DA629402F46.html","menu": {"hasChildren":true,},"tocID":"GUID-D0594A4B-99B7-41F9-869A-0DA629402F46-d58e113521","next":"GUID-D0594A4B-99B7-41F9-869A-0DA629402F46-d58e113521",},{"title":"Configuring multicast routing","shortdesc":"<p class=\"shortdesc\"> The <span class=\"keyword\">NGFW<\/span> Engine supports static multicast, IGMP-based multicast forwarding (IGMP proxying), and multicast routing using protocol-independent \t\tmulticast (PIM). You can also configure dynamic multicast routing using the Free Range Routing (FRR) Suite on the command line. <\/p>","id":"GUID-0BCB4B35-D52B-4D0F-A022-4ABCDAFDD576","href":"GUID-0BCB4B35-D52B-4D0F-A022-4ABCDAFDD576.html","menu": {"hasChildren":true,},"tocID":"GUID-0BCB4B35-D52B-4D0F-A022-4ABCDAFDD576-d58e113633","next":"GUID-0BCB4B35-D52B-4D0F-A022-4ABCDAFDD576-d58e113633",},{"title":"Configure policy routing","shortdesc":"<p class=\"shortdesc\"> Policy routing allows you to route traffic based on both source and destination IP address. Policy routing is useful when you want to configure a different route for a destination based \t\ton the source address.<\/p>","id":"GUID-B48A9469-732C-4FED-8B4D-C004A4C0875C","href":"GUID-B48A9469-732C-4FED-8B4D-C004A4C0875C.html#GUID-B48A9469-732C-4FED-8B4D-C004A4C0875C","menu": {"hasChildren":false,},"tocID":"GUID-B48A9469-732C-4FED-8B4D-C004A4C0875C-d58e113841","topics":[]},{"title":"Configure DHCP message routing","shortdesc":"<p class=\"shortdesc\"> The firewall can relay DHCP messages. If DHCP messages are routed through the firewall (from a network segment to some other, isolated segment), you must enable DHCP relay on the firewall interface properties for the interface where the DHCP requests are originating from (client’s network).    <\/p>","id":"GUID-977CC25E-EBE8-468B-8627-1FEFB30EDA7E","href":"GUID-977CC25E-EBE8-468B-8627-1FEFB30EDA7E.html","menu": {"hasChildren":true,},"tocID":"GUID-977CC25E-EBE8-468B-8627-1FEFB30EDA7E-d58e113906","next":"GUID-977CC25E-EBE8-468B-8627-1FEFB30EDA7E-d58e113906",},{"title":"Check routes using the Route Query tool","shortdesc":"<p class=\"shortdesc\"> The Route Query tool allows you to check where packets with a certain IP address are routed according to the current definitions.  You can check that the routing is correct and quickly         find a particular branch in the Routing tree. <\/p>","id":"GUID-336EF736-36DD-4589-A4D7-AB82257BD906","href":"GUID-336EF736-36DD-4589-A4D7-AB82257BD906.html#GUID-336EF736-36DD-4589-A4D7-AB82257BD906","menu": {"hasChildren":false,},"tocID":"GUID-336EF736-36DD-4589-A4D7-AB82257BD906-d58e114080","topics":[]},{"title":"Remove static routes","shortdesc":"<p class=\"shortdesc\"> New networks are automatically added to routing when you change the properties of an interface. However, the Networks are not automatically removed, so you must check the routing         configuration for obsolete entries and remove them manually.<\/p>","id":"GUID-F734D72F-44C4-4765-99C7-9E43587DEA87","href":"GUID-F734D72F-44C4-4765-99C7-9E43587DEA87.html#GUID-F734D72F-44C4-4765-99C7-9E43587DEA87","menu": {"hasChildren":false,},"tocID":"GUID-F734D72F-44C4-4765-99C7-9E43587DEA87-d58e114146","topics":[]},{"title":"Modifying antispoofing","shortdesc":"<p class=\"shortdesc\">IP address spoofing is an attack where the source IP address in a packet is changed to gain unauthorized access or to cause a denial-of-service. Such attacks can be prevented with \t\tantispoofing rules.  <\/p>","id":"GUID-B946907D-A955-4A5B-98C5-4943BA5687A5","href":"GUID-B946907D-A955-4A5B-98C5-4943BA5687A5.html","menu": {"hasChildren":true,},"tocID":"GUID-B946907D-A955-4A5B-98C5-4943BA5687A5-d58e114211","next":"GUID-B946907D-A955-4A5B-98C5-4943BA5687A5-d58e114211",},{"title":"Examples of routing configuration","shortdesc":"<p class=\"shortdesc\"> The <span class=\"keyword\">SMC<\/span> provides features that allow you to configure many routing scenarios. <\/p>","id":"GUID-D3F8586F-BFBD-4438-8EFD-FB0F0B819245","href":"GUID-D3F8586F-BFBD-4438-8EFD-FB0F0B819245.html","menu": {"hasChildren":true,},"tocID":"GUID-D3F8586F-BFBD-4438-8EFD-FB0F0B819245-d58e114369","next":"GUID-D3F8586F-BFBD-4438-8EFD-FB0F0B819245-d58e114369",}]});