define({"topics" : [{"title":"VPN certificates and how they work","shortdesc":"<p class=\"shortdesc\">Certificates can be used for authenticating VPN gateways and the <span class=\"keyword\">Forcepoint VPN Client<\/span>. <\/p>","id":"GUID-31792AA0-5D4C-40FB-8B90-139F0B713E5A","href":"GUID-31792AA0-5D4C-40FB-8B90-139F0B713E5A.html","menu": {"hasChildren":true,},"tocID":"GUID-31792AA0-5D4C-40FB-8B90-139F0B713E5A-d58e154284","next":"GUID-31792AA0-5D4C-40FB-8B90-139F0B713E5A-d58e154284",},{"title":"Define additional VPN certificate authorities","shortdesc":"<p class=\"shortdesc\">If you want to use certificates that are signed by an external CA, define an additional VPN CA.<\/p>","id":"GUID-527AC89E-E159-4A66-A4CB-CD59C53514A4","href":"GUID-527AC89E-E159-4A66-A4CB-CD59C53514A4.html#GUID-527AC89E-E159-4A66-A4CB-CD59C53514A4","menu": {"hasChildren":false,},"tocID":"GUID-527AC89E-E159-4A66-A4CB-CD59C53514A4-d58e154507","topics":[]},{"title":"Create an internal ECDSA certificate authority for VPN gateways","shortdesc":"<p class=\"shortdesc\"> The Elliptic Curve Digital Signature Algorithm (ECDSA) is a digital signature algorithm that uses elliptic curve cryptography. If you want to use the ECDSA signature algorithm for signing         VPN certificates, create an Internal ECDSA CA for Gateways. <\/p>","id":"GUID-BBDEB994-2B9D-4E35-A72E-6ADE7E731981","href":"GUID-BBDEB994-2B9D-4E35-A72E-6ADE7E731981.html","menu": {"hasChildren":false,},"tocID":"GUID-BBDEB994-2B9D-4E35-A72E-6ADE7E731981-d58e154748","topics":[]},{"title":"Select the default internal certificate authority","shortdesc":"<p class=\"shortdesc\"> If you have both an Internal RSA CA for Gateways and an Internal ECDSA CA for Gateways, only one certificate authority can be selected as the default certificate authority.    <\/p>","id":"GUID-64946ECE-F558-4081-A7C9-711D381FBCE0","href":"GUID-64946ECE-F558-4081-A7C9-711D381FBCE0.html","menu": {"hasChildren":false,},"tocID":"GUID-64946ECE-F558-4081-A7C9-711D381FBCE0-d58e154779","topics":[]},{"title":"Create a VPN certificate or certificate request for a VPN Gateway element","shortdesc":"<p class=\"shortdesc\"> You can create a certificate request and sign it either using an Internal CA for Gateways or an external certificate authority (CA).    <\/p>","id":"GUID-78793024-C897-4EE0-90BA-C785C4B86470","href":"GUID-78793024-C897-4EE0-90BA-C785C4B86470.html#GUID-78793024-C897-4EE0-90BA-C785C4B86470","menu": {"hasChildren":false,},"tocID":"GUID-78793024-C897-4EE0-90BA-C785C4B86470-d58e154810","topics":[]},{"title":"Import an externally signed VPN gateway certificate","shortdesc":"<p class=\"shortdesc\"> You can import a certificate signed by an external certificate issuer for a VPN Gateway element when the certificate request has been created in the <span class=\"keyword\">SMC<\/span>. <\/p>","id":"GUID-5D95586F-257D-4900-BDD1-D852ABE5F939","href":"GUID-5D95586F-257D-4900-BDD1-D852ABE5F939.html#GUID-5D95586F-257D-4900-BDD1-D852ABE5F939","menu": {"hasChildren":false,},"tocID":"GUID-5D95586F-257D-4900-BDD1-D852ABE5F939-d58e154961","topics":[]},{"title":"Sign external VPN certificate requests with an internal certificate authority","shortdesc":"<p class=\"shortdesc\"> You can use an internal certificate authority to sign VPN certificate requests for VPN clients and internal VPN gateways.    <\/p>","id":"GUID-656EA8E3-E778-424C-B505-BDD756A209AB","href":"GUID-656EA8E3-E778-424C-B505-BDD756A209AB.html#GUID-656EA8E3-E778-424C-B505-BDD756A209AB","menu": {"hasChildren":false,},"tocID":"GUID-656EA8E3-E778-424C-B505-BDD756A209AB-d58e155026","topics":[]},{"title":"Select which internal certificate authority signs each certificate","shortdesc":"<p class=\"shortdesc\"> When there is more than one valid CA, you can select which CA signs each certificate.    <\/p>","id":"GUID-E2BE80BB-0059-47ED-9A6D-31C35F7BE954","href":"GUID-E2BE80BB-0059-47ED-9A6D-31C35F7BE954.html#GUID-E2BE80BB-0059-47ED-9A6D-31C35F7BE954","menu": {"hasChildren":false,},"tocID":"GUID-E2BE80BB-0059-47ED-9A6D-31C35F7BE954-d58e155138","topics":[]},{"title":"Replacing expired VPN certificates","shortdesc":"<p class=\"shortdesc\">For security reasons, VPN certificates have an expiration date, after which the certificates must be replaced with new ones. <\/p>","id":"GUID-5EC0F324-132F-4B7D-BDAE-1E67C06C293A","href":"GUID-5EC0F324-132F-4B7D-BDAE-1E67C06C293A.html","menu": {"hasChildren":true,},"tocID":"GUID-5EC0F324-132F-4B7D-BDAE-1E67C06C293A-d58e155219","next":"GUID-5EC0F324-132F-4B7D-BDAE-1E67C06C293A-d58e155219",},{"title":"Export signed VPN gateway certificates or VPN certificate authority certificates","shortdesc":"<p class=\"shortdesc\">You can export signed gateway certificates, the certificates of the Internal RSA CA for Gateways, and the certificates of the Internal ECDSA CA for Gateways. <\/p>","id":"GUID-CC1AC3F5-D068-4D58-9C29-44B782CFAC12","href":"GUID-CC1AC3F5-D068-4D58-9C29-44B782CFAC12.html","menu": {"hasChildren":true,},"tocID":"GUID-CC1AC3F5-D068-4D58-9C29-44B782CFAC12-d58e155374","next":"GUID-CC1AC3F5-D068-4D58-9C29-44B782CFAC12-d58e155374",},{"title":"Check when VPN gateway certificates expire","shortdesc":"<p class=\"shortdesc\">Certificates expire according to the information written in the certificate when it was generated <\/p>","id":"GUID-FD24B110-BCB4-4D14-B020-CE0E4178ADF7","href":"GUID-FD24B110-BCB4-4D14-B020-CE0E4178ADF7.html","menu": {"hasChildren":false,},"tocID":"GUID-FD24B110-BCB4-4D14-B020-CE0E4178ADF7-d58e155468","topics":[]},{"title":"Check when VPN certificate authorities expire","shortdesc":"<p class=\"shortdesc\">The Internal RSA CA for Gateways and the Internal ECDSA CA for Gateways are valid for 10 years. <\/p>","id":"GUID-1498AAED-08E9-4F0E-A763-A61B479315E0","href":"GUID-1498AAED-08E9-4F0E-A763-A61B479315E0.html","menu": {"hasChildren":false,},"tocID":"GUID-1498AAED-08E9-4F0E-A763-A61B479315E0-d58e155499","topics":[]}]});